package LogicPatch
{
	function CreateStraightthroughElementVisual(%startbrick,%localpos,%scale)
	{
		%GlobalPosition = CalcPositionOfElement(%startbrick,%localpos);
		%SEv = new StaticShape()
		{
			dataBlock = "InputElementVisualData";
			position = %globalPosition;
			rotation = "1 0 0 0";
		    scale = %scale;
			gate = %startbrick;
		};
		return %SEv;
	}

	function PlantMerger(%data,%this,%onload) //Credit for this function goes to MeltingPlastic, except for modifications which were made by me and denoted by "+" in comments
	{
	
		if(%data.IsLogicBrick || %this.IsLogicBrick)//this is for the setiswire event that will call this after the brick exsists
		{
			%this.IsLogicBrick = true;
			%this.justloaded = %onload;
			if(%data.IsWire || %this.IsWire)
			{
				%this.IsWire = true;
				%this.state = 0;
				%this.WG = null;
			
				BakeNeighbors(%this,1);
				if(%onload)
				{
				RegisterNewWireBrick(%this);
			
				}
				else
				{
			
				RegisterNewWireBrick(%this);
				}
			}
			if(%data.IsGate)
			{
				%this.IsGate = true;
				%this.GateName = %data.GateName;
				%this.DontDisplayTips = %data.DontDisplayTips;
				%this.TipInfo = %data.TipInfo;
				
				%this.ISINSTANT = %data.ISINSTANT;
			
			
			
				%this.numPE = %data.numPE;
				%this.numIE = %data.numIE;
				if(%data.numSE !$= "")			//+
				{					//+
					%this.numSE = %data.numSE;	//+
				}					//+
				else					//+
				{					//+
					%this.numSE = 0;		//+
				}					//+

			
			
				for(%p=0;%p<%this.numPE;%p++)
				{
					%this.PE[%p] = CreatePowerElement(%this,%data.PEPos[%p],%data.PEScale[%p]);
					%this.PE[%p].Name = %data.PEName[%p];
					if(!%data.PENoRender[%p])
					{
						%this.PEv[%p] = CreatePowerElementVisual(%this,%data.PEpos[%p],%data.PEScale[%p]);
					}
					%this.PE[%p].On = %data.PEStart[%p];
				}
			
				for(%i=0;%i<%this.numIE;%i++)
				{
					%this.IE[%i] = CreateInputElement(%this,%data.IEpos[%i],%data.IEScale[%i]);
					%this.IE[%i].NOTRIG = %data.IENOTRIG[%i];//just in case the input is not trigerable.
					%this.IE[%i].Name = %data.IEName[%i];
					if(!%data.IENoRender[%p])
					{
						%this.IEv[%i] = CreateInputElementVisual(%this,%data.IEpos[%i],%data.IEScale[%i]);
					}
				}

				for(%o=0;%o<%this.numSE;%o++)											//+
				{														//+
					%i++;													//+
					%p++;													//+
					%this.IE[%i] = CreateInputElement(%this,%data.SEpos[%o],%data.SEScale[%o]);				//+
					%this.IE[%i].NOTRIG = %data.SENOTRIG[%o];//just in case the input is not trigerable.			//+
					%this.IE[%i].Name = %data.SEName[%o];									//+
					if(!%data.SENoRender[%o])										//+
					{													//+
						%this.IEv[%i] = CreateStraightthroughElementVisual(%this,%data.SEpos[%o],%data.SEScale[%o]);	//+
					}													//+
					%this.PE[%p] = CreatePowerElement(%this,%data.SEpos[%o],%data.SEScale[%o]);				//+
					%this.PE[%p].Name = %data.SEName[%o];									//+
					%this.PE[%p].On = %data.SEStart[%o];									//+
				}														//+
			
				RegisterNewGateBrick(%this);
			
			}
		}
	}
};
ActivatePackage(LogicPatch);